CREATE TABLE NNDATA_EXPORT (
  ID_NNDATA_EXPORT NUMBER NOT NULL,
  NAME VARCHAR2(100 CHAR),
  DESCRIPTION VARCHAR2(100 CHAR),
  EXPORT_FILE_NAME VARCHAR2(100 CHAR),
  EXPORT_FILE_PATH VARCHAR2(200 CHAR),
  DELIMITER VARCHAR2(3 CHAR),
  QUOTE_CHARACTER VARCHAR2(3 CHAR),
  ID_EXPORT_FORMAT NUMBER,
  NNLOCATION_ID NUMBER,
  ID_TIMER_DATA NUMBER,
  ID_QUERY NUMBER,  
  ACTIVE VARCHAR2(1 CHAR),
  CONSTRAINT NNDATA_EXPORT_PK PRIMARY KEY (ID_NNDATA_EXPORT),
  CONSTRAINT NNDATA_EXPORT_NNLOCATION_ID_FK FOREIGN KEY (NNLOCATION_ID) REFERENCES NNLOCATION(ID),
  CONSTRAINT NNDATA_EXPORT_ID_TIMER_DATA_FK FOREIGN KEY (ID_TIMER_DATA) REFERENCES TIMER_DATA(ID_TIMER_DATA),
  CONSTRAINT NNDATA_EXPORT_ID_QUERY_FK FOREIGN KEY (ID_QUERY) REFERENCES QUERY(ID_QUERY)
);

ALTER TABLE NNDATA_EXPORT
ADD DATE_FORMAT_PATTERN VARCHAR2(50 CHAR);

ALTER TABLE NNDATA_EXPORT
ADD DATE_FORMAT_LOCALE VARCHAR2(5 CHAR);

ALTER TABLE NNDATA_EXPORT
ADD NUMBER_FORMAT_PATTERN VARCHAR2(50 CHAR);

ALTER TABLE NNDATA_EXPORT
ADD NUMBER_FORMAT_LOCALE VARCHAR2(5 CHAR);

CREATE INDEX IX_NNDATA_EXP_ID_EXPORT_FORMAT ON NNDATA_EXPORT(ID_EXPORT_FORMAT);

CREATE SEQUENCE NNDATA_EXPORT_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE OR REPLACE VIEW V_NNDATA_EXPORT AS (
  SELECT NE.ID_NNDATA_EXPORT, NE.NAME, NE.DESCRIPTION, NE.EXPORT_FILE_NAME, NE.EXPORT_FILE_PATH, NE.ID_EXPORT_FORMAT, NE.NNLOCATION_ID, NE.ID_TIMER_DATA, NE.ID_QUERY, NE.ACTIVE,
  TD.TIMER_ID AS TIMER_ID, QU.NAME AS QUERY_NAME
  FROM NNDATA_EXPORT NE
  LEFT OUTER JOIN TIMER_DATA TD ON TD.ID_TIMER_DATA = NE.ID_TIMER_DATA
  LEFT OUTER JOIN QUERY QU ON QU.ID_QUERY = NE.ID_QUERY
);

ALTER TABLE QUERY_COLUMN
ADD DESCRIPTION VARCHAR2(150 CHAR);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1482, SYSDATE, '5.5', 1402, 'Data export')
;