ALTER TABLE NN_AMPERAGE MODIFY OPIS VARCHAR2(20 CHAR);

ALTER TABLE VOUCHER
ADD REFERENCE_NUMBER VARCHAR2(50 CHAR);

DROP VIEW V_VOUCHER;

CREATE OR REPLACE VIEW V_VOUCHER AS (
  SELECT V.ID_VOUCHER, V.ID_TYPE, V.ID_LASTNIKA, V.UNIQUE_NUMBER, V.REFERENCE_NUMBER, V.DATE_CREATED, V.MAIN_DATE, V.EXPIRY_DATE, V.WRITE_OFF_DATE, V.AMOUNT, 
  V.NNLOCATION_ID, V.NOTE, V.ACTIVE, VT.DESCRIPTION AS TYPE_DESCRIPTION, VT.TYPE AS TYPE_TYPE,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  COALESCE(VM.USED_AMOUNT,0) AS USED_AMOUNT, V.AMOUNT - COALESCE(VM.USED_AMOUNT,0) AS OPEN_AMOUNT, (CASE WHEN VM.USED_AMOUNT = V.AMOUNT THEN 'Y' ELSE 'N' END) AS CLOSED,
  (CASE WHEN (SELECT COUNT(K.CTRL) FROM KNJIZBE K WHERE K.ID_VOUCHER = V.ID_VOUCHER) > 0 THEN 'Y' ELSE 'N' END) AS BOOKKEEPING_EXECUTED
  FROM VOUCHER V
  LEFT OUTER JOIN VOUCHER_TYPE VT ON VT.ID_VOUCHER_TYPE = V.ID_TYPE
  LEFT OUTER JOIN KUPCI K ON K.ID = V.ID_LASTNIKA
  LEFT OUTER JOIN V_VOUCHER_MONEY VM ON VM.ID_VOUCHER = V.ID_VOUCHER
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1722, SYSDATE, '5.5', 1642, 'Voucher ref num')
;