UPDATE USER_SHORTCUT_PARAM
SET NUMBER_VALUE = 86
WHERE TYPE = 'VID' AND NUMBER_VALUE = 16
AND ID_USER_SHORTCUT IN (SELECT ID_USER_SHORTCUT FROM USER_SHORTCUT_PARAM WHERE TYPE = 'SID' AND NUMBER_VALUE = 86);

DELETE FROM USER_SHORTCUT_PARAM
WHERE TYPE = 'SID' AND NUMBER_VALUE = 86;

CREATE TABLE NNENQUIRY_BOAT_LENGTH(
	CODE VARCHAR2(3 CHAR),
	DESCRIPTION VARCHAR2(100 CHAR),
	INTERNAL_DESCRIPTION VARCHAR2(100 CHAR),
	ACT VARCHAR2(1 CHAR),
	CONSTRAINT NNENQUIRY_BOAT_LENGTH_PK PRIMARY KEY (CODE)
);

ALTER TABLE ENQUIRY
ADD BOAT_LENGTH_ID VARCHAR2(3 CHAR);

ALTER TABLE ENQUIRY
ADD CONSTRAINT ENQUIRY_BOAT_LENGTH_FK
FOREIGN KEY (BOAT_LENGTH_ID)
REFERENCES NNENQUIRY_BOAT_LENGTH(CODE);

CREATE INDEX IX_ENQUIRY_BOAT_LENGTH ON ENQUIRY (BOAT_LENGTH_ID);

DROP VIEW V_KUPCI;

CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.TELEFON_2, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, K.DATUM_SPREMEMBE, K.DATUM_KREIRANJA,
	K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM, K.BELEZKA, K.MANAGER, K.ACT, K.KODA_JEZIKA, K.CODE_REFERRAL, K.LOYALTY, K.LOYALTY_CODE, K.DAVCNA_STEVILKA, K.SEND_TEXT, K.ID_EXTERNAL, K.DATE_EXTERNAL,
  ENQ.INITIAL_CONTACT_DATE, ENQ.SELL_PHASE, ENQ.BOAT_LOCATION_ID, ENQ.SELL_PHASE_STATUS AS SELL_PHASE_STATUS, ENQ.BOAT_LENGTH_ID AS ENQUIRY_BOAT_LENGTH_ID,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.OPIS AS VRSTA_OPIS, NNVRS.INTERNI_OPIS AS VRSTA_DESC, NNVRSLOY.OPIS AS LOYALTY_TYPE_DESCRIPTION,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC, NNUSR.USER_ AS MANAGER_USER,
  NSP.OPIS AS SELL_PHASE_OPIS, NNLB.OPIS AS BOAT_LOCATION_OPIS,
  (SELECT LISTAGG(NV.OPIS,', ') WITHIN GROUP(ORDER BY NV.OPIS ASC) TYPES FROM KUPCI_VRSTA KV, NNVRSKUP NV WHERE NV.SIFRA = KV.VRSTA AND KV.ID_KUPCA = K.ID) AS TYPES_DESCRIPTIONS,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  ENQ.CONVERSION_DATE, K.START_YC_MEMBERSHIP
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
  LEFT OUTER JOIN NNVRSKUP NNVRSLOY ON K.LOYALTY_CODE = NNVRSLOY.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN ENQUIRY ENQ ON K.ID = ENQ.ID_KUPCA
  LEFT OUTER JOIN NNSELL_PHASE NSP ON ENQ.SELL_PHASE = NSP.SIFRA
  LEFT OUTER JOIN NNLOCATION NNLB ON ENQ.BOAT_LOCATION_ID = NNLB.ID
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1872, SYSDATE, '5.5', 1792, 'Enquiry')
;
