ALTER TABLE PLOVILA_SVG
ADD (
  ID_PRESPR NUMBER DEFAULT 0
);

ALTER TABLE PLOVILA_SVG 
DROP CONSTRAINT PLOVILA_SVG_PK;

ALTER TABLE PLOVILA_SVG 
ADD CONSTRAINT PLOVILA_SVG_PK PRIMARY KEY (ID, PRISOTNO, ID_PLOVILA, ID_PRESPR);


CREATE TABLE PRESPR_PRIVEZI (
  ID_PRESPR NUMBER NOT NULL 
, ID_PRIVEZ NUMBER NOT NULL 
, OBJEKT VARCHAR2(8 CHAR) NOT NULL
, N_PRIVEZA VARCHAR2(12 CHAR) NOT NULL
, ZAC_PRIVEZ VARCHAR2(1 CHAR) NOT NULL
, CEL_PRIVEZ VARCHAR2(1 CHAR) NOT NULL
, DEL1 VARCHAR2(1 CHAR) NOT NULL
, DEL2 VARCHAR2(1 CHAR) NOT NULL
, CONSTRAINT PRESPR_PRIVEZI_PK PRIMARY KEY 
  (
    ID_PRESPR,
    ID_PRIVEZ
  )
  ENABLE
);

CREATE OR REPLACE VIEW V_REZERVAC AS (
SELECT R.ID, 0 AS PRISOTNO, R.DATUM_REZERVACIJE, R.DATUM_DO, R.ID_LASTNIKA, R.ID_PLOVILA, 0 AS ID_PRESPR, R.NAZIV, R.PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ
, R.DOLZINA, R.SIRINA, R.GREZ, '' AS NTIP 
FROM REZERVAC R 
LEFT OUTER JOIN NNPRIVEZ NP ON R.NOBJEKT=NP.OBJEKT AND R.PRIVEZ=NP.N_PRIVEZA 
WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL
UNION ALL
SELECT 0 as ID, (CASE WHEN T.ID_PRIVEZ=PR.ID_PRIVEZ THEN 1 ELSE 0 END) AS PRISOTNO, 
(CASE WHEN T.ID_PRIVEZ=PR.ID_PRIVEZ THEN NVL(P.TRENUTNO_DO, TRUNC(SYSDATE)) ELSE TRUNC(SYSDATE+1) END) AS DATUM_REZERVACIJE, 
NVL(POG.DATUM_KONCA, TRUNC(SYSDATE)+365) AS DATUM_DO, 
POG.ID_LASTNIKA, POG.ID_PLOVILA, 0 AS ID_PRESPR, K.PRIIMEK AS NAZIV, P.IME AS PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ 
, P.DOLZINA, P.SIRINA, P.GREZ, P.NTIP 
FROM M_POGODBE POG 
JOIN PRIVEZI PR ON PR.ID_POGODBE=POG.ID_POGODBE
JOIN PLOVILA P ON POG.ID_PLOVILA=P.ID
JOIN KUPCI K ON POG.ID_LASTNIKA=K.ID 
LEFT OUTER JOIN NNPRIVEZ NP ON PR.ID_PRIVEZ=NP.ID_PRIVEZ 
LEFT OUTER JOIN PRIVEZI T ON T.ID_PLOVILA=POG.ID_PLOVILA AND T.ID_POGODBE IS NULL AND T.ID_PRIVEZ=PR.ID_PRIVEZ
WHERE POG.STATUS IN ('O', 'A')
UNION ALL
SELECT 0 as ID, 1 AS PRISOTNO, TRUNC(SYSDATE) AS DATUM_REZERVACIJE, 
TRUNC(SYSDATE) AS DATUM_DO, 
POG.ID_LASTNIKA, POG.ID_PLOVILA, 0 AS ID_PRESPR, K.PRIIMEK AS NAZIV, P.IME AS PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ 
, P.DOLZINA, P.SIRINA, P.GREZ, P.NTIP 
FROM M_POGODBE POG 
JOIN PRIVEZI PR ON PR.ID_POGODBE=POG.ID_POGODBE
JOIN PLOVILA P ON POG.ID_PLOVILA=P.ID
JOIN KUPCI K ON POG.ID_LASTNIKA=K.ID 
JOIN PRIVEZI T ON T.ID_PLOVILA=POG.ID_PLOVILA AND T.ID_POGODBE IS NULL AND T.ID_PRIVEZ<>PR.ID_PRIVEZ
JOIN NNPRIVEZ NP ON T.ID_PRIVEZ=NP.ID_PRIVEZ 
WHERE POG.STATUS IN ('O', 'A') AND ((P.TRENUTNI_OBJEKT_PRIVEZA<>P.POGODBENI_OBJEKT_PRIVEZA) OR (P.TRENUTNA_N_PRIVEZA<>P.POGODBENA_N_PRIVEZA))
UNION ALL
SELECT -1 as ID, 1 AS PRISOTNO, TRUNC(SYSDATE) AS DATUM_REZERVACIJE, 
(CASE WHEN P.TRENUTNO_DO>TRUNC(SYSDATE) THEN P.TRENUTNO_DO ELSE TRUNC(SYSDATE) END) AS DATUM_DO, 
P.ID_LASTNIKA, P.ID AS ID_PLOVILA, 0 AS ID_PRESPR, K.PRIIMEK AS NAZIV, P.IME AS PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ
, P.DOLZINA, P.SIRINA, P.GREZ, P.NTIP 
FROM PLOVILA P 
JOIN PRIVEZI PR ON PR.ID_PLOVILA=P.ID
JOIN KUPCI K ON P.ID_LASTNIKA=K.ID
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ=PR.ID_PRIVEZ 
WHERE (PR.ID_POGODBE IS NULL) AND 
(P.ID NOT IN (SELECT ID_PLOVILA FROM M_POGODBE WHERE STATUS IN ('O', 'A')))
UNION ALL
SELECT -2 AS ID, 1 AS PRISOTNO, TRUNC(SYSDATE) AS DATUM_REZERVACIJE, TRUNC(SYSDATE) AS DATUM_DO, 0 AS ID_LASTNIKA, 0 AS ID_PLOVILA, P.ID AS ID_PRESPR, 
P.PRIIMEK AS NAZIV, P.IME_PLOVILA AS PLOVILO, PR.OBJEKT AS NOBJEKT, PR.N_PRIVEZA AS PRIVEZ, PR.ID_PRIVEZ AS ID_PRIVEZ, P.DOLZINA AS DOLZINA, NULL AS SIRINA, NULL AS GREZ, P.NTIP AS NTIP
FROM PRESPR P
JOIN PRESPR_PRIVEZI PR ON PR.ID_PRESPR = P.ID
WHERE (P.STATUS = 'N') AND (P.TIP_DOG = 'PT')
);


CREATE OR REPLACE VIEW V_REZERVAC_SVG AS (
SELECT DISTINCT V.ID, V.PRISOTNO, V.DATUM_REZERVACIJE, V.DATUM_DO, V.ID_LASTNIKA, V.ID_PLOVILA, V.ID_PRESPR, V.ID_PRIVEZ, NVL(V.PLOVILO, NVL(V.NAZIV, 'UNKNOWN')) AS IME_PLOVILA, NVL(V.NTIP, 'V') AS TIP_PLOVILA,
NVL(V.DOLZINA, 10) AS DOLZINA_PLOVILA, NVL(V.SIRINA, 3) AS SIRINA_PLOVILA, PS.TRANS_X AS TRANS_X_PLOVILA, PS.TRANS_Y AS TRANS_Y_PLOVILA, PS.ROT_DEGREES AS ROT_DEGREES_PLOVILA,
NVL(N.DOLZINA, 10) AS DOLZINA_PRIVEZA, NVL(N.SIRINA, 5) AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA, N.OBJEKT
FROM V_REZERVAC V
JOIN NNPRIVEZ N ON N.ID_PRIVEZ = V.ID_PRIVEZ
JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = V.ID_PRIVEZ
LEFT JOIN PLOVILA_SVG PS ON PS.ID = V.ID AND PS.PRISOTNO = V.PRISOTNO AND PS.ID_PLOVILA = V.ID_PLOVILA AND PS.ID_PRESPR = V.ID_PRESPR
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (317, SYSDATE, '5.5', 237, 'Predsprejem tranzitnih plovil');