CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL,
  P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNI_OBJEKT_PRIVEZA, P.TRENUTNA_N_PRIVEZA, P.TRENUTNO_DO, P.POGODBENI_OBJEKT_PRIVEZA, P.POGODBENA_N_PRIVEZA, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA,
  P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
);

CREATE OR REPLACE VIEW V_RESERVATIONS_MANAGEMENT AS 
(
SELECT 'ALARM_ARRIVAL' AS CATEGORY, CONCAT('ALARM_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) < TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )

UNION ALL

SELECT 'ALARM_DEPARTURE' AS CATEGORY, CONCAT('ALARM_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) <= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)

UNION ALL

SELECT 'ALARM_MOVE' AS CATEGORY, CONCAT('ALARM_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')

UNION ALL

SELECT 'ALARM_EXIT' AS CATEGORY, CONCAT('ALARM_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')

UNION ALL

SELECT 'ALARM_RETURN' AS CATEGORY, CONCAT('ALARM_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE='Y')

UNION ALL

SELECT 'PLAN_ARRIVAL' AS CATEGORY, CONCAT('PLAN_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) >= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )

UNION ALL

SELECT 'PLAN_DEPARTURE' AS CATEGORY, CONCAT('PLAN_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.STATUS_REZERVAC, RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_DO) > TRUNC(SYSDATE) AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS 
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)

UNION ALL

SELECT 'PLAN_MOVE' AS CATEGORY, CONCAT('PLAN_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND NOT EXISTS 
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)

UNION ALL

SELECT 'PLAN_EXIT' AS CATEGORY, CONCAT('PLAN_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N')

UNION ALL

SELECT 'PLAN_RETURN' AS CATEGORY, CONCAT('PLAN_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND EXISTS 
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)

UNION ALL

SELECT 'CURRENT_PRESENT' AS CATEGORY, CONCAT('CURRENT_PRESENT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE = 'Y')

UNION ALL

SELECT 'CURRENT_EXIT' AS CATEGORY, CONCAT('CURRENT_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, DE.STATUS_REZERVAC, DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, NN.N_PRIVEZA, KU.SALDAKONTI_SIT, KU.ID_MEMBER,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE = 'Y')
)
;

CREATE OR REPLACE VIEW V_REZERVAC AS (
SELECT R.ID AS ID_REZERVAC, D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_OD AS RD_DATE_FROM, D.DATUM_DO AS RD_DATE_TO,
RDNP.OBJEKT AS RD_OBJEKT, RDNP.N_PRIVEZA AS RD_N_PRIVEZA, RDNP.ID_PRIVEZ AS RD_ID_PRIVEZ, R.VRSTA, D.STATUS_REZERVAC AS RD_STATUS_REZERVAC, D.COMPLETE AS RD_COMPLETE, D.VRSTA AS RD_VRSTA,
R.ID_LASTNIKA, R.ID_PLOVILA, NNO.OBJECT_TYPE, NNO.OBLIKA AS NNOBJEKT_OBLIKA, NNO.CENTER_POZICIJA_PLOVILA AS CENTER_POZICIJA_PLOVILA, MP.OBJEKT AS POGODBA_OBJEKT, MP.N_PRIVEZA AS POGODBA_N_PRIVEZA, R.DATUM_REZERVACIJE AS R_DATE_FROM, R.DATUM_DO AS R_DATE_TO,
RNP.OBJEKT AS R_OBJEKT, RNP.N_PRIVEZA AS R_N_PRIVEZA, RNP.ID_PRIVEZ AS R_ID_PRIVEZ, R.STATUS_REZERVAC AS R_STATUS_REZERVAC,
NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA,
RD.TRANS_X AS TRANS_X_PLOVILA, RD.TRANS_Y AS TRANS_Y_PLOVILA, RD.ROT_DEGREES AS ROT_DEGREES_PLOVILA, R.KOMENTAR, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.EMAIL ELSE K.EMAIL END) AS EMAIL,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.TELEFON ELSE K.TELEFON_1 END) AS TELEFON,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.VISINA ELSE P.VISINA END) AS VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.DOLZINA ELSE NT.DOLZINA END) AS NNTIP_DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SIRINA ELSE NT.SIRINA END) AS NNTIP_SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.VISINA ELSE NT.VISINA END) AS NNTIP_VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
LEFT OUTER JOIN NNPRIVEZ RDNP ON D.ID_PRIVEZ=RDNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ RNP ON R.ID_PRIVEZ=RNP.ID_PRIVEZ
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = RDNP.OBJEKT
LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
LEFT OUTER JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = D.ID_PRIVEZ
LEFT OUTER JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC_DETAIL = D.ID_REZERVAC_DETAIL
WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL
UNION ALL
SELECT R.ID AS ID_REZERVAC, -D.ID_REZERVAC_DETAIL, R.ID_POGODBE, R.DATUM_DO AS RD_DATE_FROM, TRUNC(SYSDATE) + 1 AS RD_DATE_TO,
RDNP.OBJEKT AS RD_OBJEKT, RDNP.N_PRIVEZA AS RD_N_PRIVEZA, RDNP.ID_PRIVEZ AS RD_ID_PRIVEZ, R.VRSTA, -10 AS RD_STATUS_REZERVAC, D.COMPLETE AS RD_COMPLETE, D.VRSTA AS RD_VRSTA,
R.ID_LASTNIKA, R.ID_PLOVILA, NNO.OBJECT_TYPE, NNO.OBLIKA AS NNOBJEKT_OBLIKA, NNO.CENTER_POZICIJA_PLOVILA AS CENTER_POZICIJA_PLOVILA, MP.OBJEKT AS POGODBA_OBJEKT, MP.N_PRIVEZA AS POGODBA_N_PRIVEZA, R.DATUM_REZERVACIJE AS R_DATE_FROM, R.DATUM_DO AS R_DATE_TO,
RNP.OBJEKT AS R_OBJEKT, RNP.N_PRIVEZA AS R_N_PRIVEZA, RNP.ID_PRIVEZ AS R_ID_PRIVEZ, R.STATUS_REZERVAC AS R_STATUS_REZERVAC,
NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA,
RD.TRANS_X AS TRANS_X_PLOVILA, RD.TRANS_Y AS TRANS_Y_PLOVILA, RD.ROT_DEGREES AS ROT_DEGREES_PLOVILA, R.KOMENTAR, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.EMAIL ELSE K.EMAIL END) AS EMAIL,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.TELEFON ELSE K.TELEFON_1 END) AS TELEFON,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.VISINA ELSE P.VISINA END) AS VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.DOLZINA ELSE NT.DOLZINA END) AS NNTIP_DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SIRINA ELSE NT.SIRINA END) AS NNTIP_SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.VISINA ELSE NT.VISINA END) AS NNTIP_VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
LEFT OUTER JOIN NNPRIVEZ RDNP ON D.ID_PRIVEZ=RDNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ RNP ON R.ID_PRIVEZ=RNP.ID_PRIVEZ
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = RDNP.OBJEKT
LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
LEFT OUTER JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = D.ID_PRIVEZ
LEFT OUTER JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC_DETAIL = -D.ID_REZERVAC_DETAIL
WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL 
AND R.STATUS_REZERVAC = 1 AND R.DATUM_DO <= TRUNC(SYSDATE) AND D.ID_REZERVAC_DETAIL IN 
(SELECT ID_REZERVAC_DETAIL FROM REZERVAC_DETAIL WHERE DATUM_DO = 
(SELECT MAX(D2.DATUM_DO) FROM REZERVAC_DETAIL D2 WHERE D2.STATUS_REZERVAC = 1 AND D2.COMPLETE = 'Y' AND D2.ID_REZERVAC = R.ID))
);

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(513, SYSDATE, '5.5', 433, 'Dodan ID_MEMBER');